'------------------------------------------------------------------------------------------------
'
'
' Usage: cvdir virtualDir,physicalDir
'
' Example: cvdir MyVirtualDir,c:\temp
'------------------------------------------------------------------------------------------------

' Force explicit declaration of all variables.
Option Explicit

Dim oArgs, Params

' Read parameters passed from the command line
Set oArgs = WScript.Arguments
If oArgs.Count<>1 Then
	Die("Incorrect number of arguments passed to cvdir.vbs" & vbNewLine & "Usage: cvdir virtualDir,physicalDir")
End If

' Make sure we got all four parameters
Params=Split(oArgs(0), ",", -1, 1)
If UBound(Params)<>1 Then
	Die("Parameter passing is not in the form: virtualDir,physicalDir")
End If

' Store parameters passed
Dim virtualDir, physicalDir
virtualDir=Params(0)
physicalDir=Params(1)

' Get WebSite object
Dim WebSite
set WebSite = GetObject("IIS://LocalHost/W3svc/1")
If Not IsObject(WebSite) Then
	Die("Unable to access WebSite object")
End If

' Get virtual root directory
Dim vRoot
set vRoot = WebSite.GetObject("IIsWebVirtualDir", "Root")
If (Err <> 0) Then
	Die("Unable to access root for " & WebSite.ADsPath)
End If

' Create a new virtual root
Dim vDir
set vDir = vRoot.Create("IIsWebVirtualDir",virtualDir)
If (Err <> 0) Then
	Die "Unable to create " & vRoot.ADsPath & "/" & virtualDir &"."
End If

' Set the new virtual directory path
vDir.AccessExecute	= true
vDir.AccessScript	= true
vDir.AccessWrite	= false
vDir.AccessRead		= true
vdir.EnableDirBrowsing = false
vDir.Path = physicalDir
vDir.AppFriendlyName = virtualDir
Vdir.EnableDefaultDoc = true
VDir.AppCreate true 
If (Err <> 0) Then
	Die "Unable to bind path " & virtualDir & " to " & physicalDir &  ". Path may be invalid."
End If

' Inform the IIS of the new virtual directory
vDir.SetInfo
If (Err <> 0) Then
	Die "Unable to save configuration for " & physicalDir & "."
End If

Sub Die(Msg)
	WScript.Echo Now & ". Error Code: " & Hex(Err) & " - " & Msg
	WScript.Quit (1)
End Sub
